package fr.obeo.acceleo.gen.ui.editors;

import java.util.HashMap;
import java.util.Map;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.swt.graphics.Image;

import fr.obeo.acceleo.ecore.tools.AdapterUtils;
import fr.obeo.acceleo.gen.ui.AcceleoEcoreGenUiPlugin;

public class EMFEditorUtil {

	private static Map iconMap = new HashMap();

	/**
	 * Get the icon for a Classifier ecore element
	 * 
	 * @param proposal
	 * @param resolveNotFound
	 *            Automaticly fix a not found image (with Ecore icons)
	 * @return
	 */
	public static Image findImageFromClassifier(EClassifier proposal, boolean resolveNotFound) {

		Image icon = null;
		if (iconMap.containsKey(proposal)) { // cache
			icon = (Image) iconMap.get(proposal);
		} else {
			AdapterFactory adFac = AdapterUtils.findAdapterFactory(proposal);
			if (adFac == null) {
				if (resolveNotFound)
					icon = findImageFromClassifier(proposal.eClass(), resolveNotFound); // use
				// ecore
				// icons
			} else {
				AdapterFactoryLabelProvider labelProvider = new AdapterFactoryLabelProvider(adFac);
				if (labelProvider != null && proposal instanceof EClass) {
					if (!((EClass) proposal).isAbstract() && !((EClass) proposal).isInterface()) { // concret
						// class
						EObject emptyObj = EcoreUtil.create((EClass) proposal);
						icon = labelProvider.getImage(emptyObj);
					} else {
						if (resolveNotFound)
							icon = findImageFromClassifier(proposal.eClass(), resolveNotFound); // use
						// ecore
						// icons
					}
				} else {
					icon = AcceleoEcoreGenUiPlugin.getDefault().getImage("icons/proposals/model_class.gif"); // never
					// reach
				}
			}
		}
		return icon;
	}
}
