/*
 * Copyright (c) 2005-2007 Obeo
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */

package fr.obeo.acceleo.gen.ui.editors.template;

import org.eclipse.jface.action.Action;
import org.eclipse.ui.IActionBars;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.texteditor.BasicTextEditorActionContributor;
import org.eclipse.ui.texteditor.ITextEditor;

import fr.obeo.acceleo.gen.ui.popupMenus.CommentAreaAction;
import fr.obeo.acceleo.gen.ui.popupMenus.OpenDefinitionAction;

/**
 * This class contributes global actions for the template editor
 * 
 * @author www.obeo.fr
 * 
 */
public class AcceleoTemplateEditorActionContributor extends BasicTextEditorActionContributor {

	public void setActiveEditor(IEditorPart part) {
		super.setActiveEditor(part);
		if (!(part instanceof ITextEditor))
			return;
		IActionBars actionBars = getActionBars();
		if (actionBars == null)
			return;
		// setting the binding for the open definition action
		Action openAction = new OpenDefinitionAction();
		openAction.setActionDefinitionId(OpenDefinitionAction.ACTION_ID);
		actionBars.setGlobalActionHandler(OpenDefinitionAction.COMMAND_ID, openAction);
		// setting the binding for the organize import action
		Action organizeImportAction = new CommentAreaAction();
		organizeImportAction.setActionDefinitionId(CommentAreaAction.ACTION_ID);
		actionBars.setGlobalActionHandler(CommentAreaAction.COMMAND_ID, organizeImportAction);
	}

}
