/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml14.behavioral_elements.state_machines;

import org.eclipse.emf.common.util.EList;

import fr.obeo.acceleo.uml14.foundation.core.ModelElement;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>State Machine</b></em>'.
 * <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.StateMachine#getContext <em>Context</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.StateMachine#getTop <em>Top</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.StateMachine#getTransitions <em>Transitions</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.StateMachine#getSubmachineState <em>Submachine State</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.State_machinesPackage#getStateMachine()
 * @model
 * @generated
 */
public interface StateMachine extends ModelElement {
	/**
	 * Returns the value of the '<em><b>Context</b></em>' reference. It is
	 * bidirectional and its opposite is '{@link fr.obeo.acceleo.uml14.foundation.core.ModelElement#getBehavior <em>Behavior</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Context</em>' reference isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Context</em>' reference.
	 * @see #setContext(ModelElement)
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.State_machinesPackage#getStateMachine_Context()
	 * @see fr.obeo.acceleo.uml14.foundation.core.ModelElement#getBehavior
	 * @model opposite="behavior"
	 * @generated
	 */
	ModelElement getContext();

	/**
	 * Sets the value of the '{@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.StateMachine#getContext <em>Context</em>}'
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Context</em>' reference.
	 * @see #getContext()
	 * @generated
	 */
	void setContext(ModelElement value);

	/**
	 * Returns the value of the '<em><b>Top</b></em>' containment
	 * reference. It is bidirectional and its opposite is '{@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.State#getStateMachine <em>State Machine</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Top</em>' containment reference isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Top</em>' containment reference.
	 * @see #setTop(State)
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.State_machinesPackage#getStateMachine_Top()
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.State#getStateMachine
	 * @model opposite="stateMachine" containment="true" required="true"
	 * @generated
	 */
	State getTop();

	/**
	 * Sets the value of the '{@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.StateMachine#getTop <em>Top</em>}'
	 * containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Top</em>' containment reference.
	 * @see #getTop()
	 * @generated
	 */
	void setTop(State value);

	/**
	 * Returns the value of the '<em><b>Transitions</b></em>' containment
	 * reference list. The list contents are of type
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.Transition}.
	 * It is bidirectional and its opposite is '{@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.Transition#getStateMachine <em>State Machine</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Transitions</em>' containment reference
	 * list isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Transitions</em>' containment reference
	 *         list.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.State_machinesPackage#getStateMachine_Transitions()
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.Transition#getStateMachine
	 * @model type="fr.obeo.acceleo.uml14.behavioral_elements.state_machines.Transition"
	 *        opposite="stateMachine" containment="true"
	 * @generated
	 */
	EList getTransitions();

	/**
	 * Returns the value of the '<em><b>Submachine State</b></em>'
	 * reference list. The list contents are of type
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SubmachineState}.
	 * It is bidirectional and its opposite is '{@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SubmachineState#getSubmachine <em>Submachine</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Submachine State</em>' reference list
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Submachine State</em>' reference list.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.State_machinesPackage#getStateMachine_SubmachineState()
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SubmachineState#getSubmachine
	 * @model type="fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SubmachineState"
	 *        opposite="submachine"
	 * @generated
	 */
	EList getSubmachineState();

} // StateMachine
