/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml14.behavioral_elements.state_machines.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;
import org.eclipse.emf.ecore.EObject;

import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.CallEvent;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.ChangeEvent;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.CompositeState;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.Event;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.FinalState;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.Guard;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.Pseudostate;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SignalEvent;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SimpleState;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.State;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.StateMachine;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.StateVertex;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.State_machinesPackage;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.StubState;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SubmachineState;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SynchState;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.TimeEvent;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.Transition;
import fr.obeo.acceleo.uml14.foundation.core.Element;
import fr.obeo.acceleo.uml14.foundation.core.ModelElement;

/**
 * <!-- begin-user-doc --> The <b>Adapter Factory</b> for the model. It
 * provides an adapter <code>createXXX</code> method for each class of the
 * model. <!-- end-user-doc -->
 * 
 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.State_machinesPackage
 * @generated
 */
public class State_machinesAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected static State_machinesPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public State_machinesAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = State_machinesPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc --> This implementation returns <code>true</code>
	 * if the object is either the model's package or is an instance object of
	 * the model. <!-- end-user-doc -->
	 * 
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject) object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch the delegates to the <code>createXXX</code> methods. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected State_machinesSwitch modelSwitch = new State_machinesSwitch() {
		public Object caseStateMachine(StateMachine object) {
			return createStateMachineAdapter();
		}

		public Object caseEvent(Event object) {
			return createEventAdapter();
		}

		public Object caseStateVertex(StateVertex object) {
			return createStateVertexAdapter();
		}

		public Object caseState(State object) {
			return createStateAdapter();
		}

		public Object caseTimeEvent(TimeEvent object) {
			return createTimeEventAdapter();
		}

		public Object caseCallEvent(CallEvent object) {
			return createCallEventAdapter();
		}

		public Object caseSignalEvent(SignalEvent object) {
			return createSignalEventAdapter();
		}

		public Object caseTransition(Transition object) {
			return createTransitionAdapter();
		}

		public Object caseCompositeState(CompositeState object) {
			return createCompositeStateAdapter();
		}

		public Object caseChangeEvent(ChangeEvent object) {
			return createChangeEventAdapter();
		}

		public Object caseGuard(Guard object) {
			return createGuardAdapter();
		}

		public Object casePseudostate(Pseudostate object) {
			return createPseudostateAdapter();
		}

		public Object caseSimpleState(SimpleState object) {
			return createSimpleStateAdapter();
		}

		public Object caseSubmachineState(SubmachineState object) {
			return createSubmachineStateAdapter();
		}

		public Object caseSynchState(SynchState object) {
			return createSynchStateAdapter();
		}

		public Object caseStubState(StubState object) {
			return createStubStateAdapter();
		}

		public Object caseFinalState(FinalState object) {
			return createFinalStateAdapter();
		}

		public Object caseElement(Element object) {
			return createElementAdapter();
		}

		public Object caseModelElement(ModelElement object) {
			return createModelElementAdapter();
		}

		public Object defaultCase(EObject object) {
			return createEObjectAdapter();
		}
	};

	/**
	 * Creates an adapter for the <code>target</code>. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @param target
	 *            the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	public Adapter createAdapter(Notifier target) {
		return (Adapter) modelSwitch.doSwitch((EObject) target);
	}

	/**
	 * Creates a new adapter for an object of class '{@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.StateMachine <em>State Machine</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.StateMachine
	 * @generated
	 */
	public Adapter createStateMachineAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.Event <em>Event</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.Event
	 * @generated
	 */
	public Adapter createEventAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.StateVertex <em>State Vertex</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.StateVertex
	 * @generated
	 */
	public Adapter createStateVertexAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.State <em>State</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.State
	 * @generated
	 */
	public Adapter createStateAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.TimeEvent <em>Time Event</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.TimeEvent
	 * @generated
	 */
	public Adapter createTimeEventAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.CallEvent <em>Call Event</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.CallEvent
	 * @generated
	 */
	public Adapter createCallEventAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SignalEvent <em>Signal Event</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SignalEvent
	 * @generated
	 */
	public Adapter createSignalEventAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.Transition <em>Transition</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.Transition
	 * @generated
	 */
	public Adapter createTransitionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.CompositeState <em>Composite State</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.CompositeState
	 * @generated
	 */
	public Adapter createCompositeStateAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.ChangeEvent <em>Change Event</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.ChangeEvent
	 * @generated
	 */
	public Adapter createChangeEventAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.Guard <em>Guard</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.Guard
	 * @generated
	 */
	public Adapter createGuardAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.Pseudostate <em>Pseudostate</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.Pseudostate
	 * @generated
	 */
	public Adapter createPseudostateAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SimpleState <em>Simple State</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SimpleState
	 * @generated
	 */
	public Adapter createSimpleStateAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SubmachineState <em>Submachine State</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SubmachineState
	 * @generated
	 */
	public Adapter createSubmachineStateAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SynchState <em>Synch State</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SynchState
	 * @generated
	 */
	public Adapter createSynchStateAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.StubState <em>Stub State</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.StubState
	 * @generated
	 */
	public Adapter createStubStateAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.FinalState <em>Final State</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.state_machines.FinalState
	 * @generated
	 */
	public Adapter createFinalStateAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link fr.obeo.acceleo.uml14.foundation.core.Element <em>Element</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.Element
	 * @generated
	 */
	public Adapter createElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link fr.obeo.acceleo.uml14.foundation.core.ModelElement <em>Model Element</em>}'.
	 * <!-- begin-user-doc --> This default implementation returns null so that
	 * we can easily ignore cases; it's useful to ignore a case when inheritance
	 * will catch all the cases anyway. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @see fr.obeo.acceleo.uml14.foundation.core.ModelElement
	 * @generated
	 */
	public Adapter createModelElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case. <!-- begin-user-doc --> This
	 * default implementation returns null. <!-- end-user-doc -->
	 * 
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} // State_machinesAdapterFactory
